#pragma once

#include "BuildLibrary.h"
#include "Error.h"

class BuildSession
{
public:
    BuildSession(const String& source_dir, 
        const String& build_dir = {});

    Status scan();

    Status build();

    Status add_library(const FileSystemPath& config_path);

private:
    Status compile_library(BuildLibrary& lib);

    Status compile_source_file(const FileSystemPath& source, 
        const BuildLibrary& lib);

    void add_include_dirs(Vector<String>& args, const BuildLibrary& lib);

    Status create_archive(BuildLibrary& lib);

    String m_compiler_command{"/usr/bin/g++"};
    String m_archive_command{"/usr/bin/ar"};
    Vector<String> m_compiler_flags;
    FileSystemPath m_source_dir;
    FileSystemPath m_build_dir;
    Vector<BuildLibrary> m_libraries;
};