#pragma once

#include "Optional.h"
#include <cstddef>

template<typename T>
class Stream
{
public:
    virtual bool good() const = 0;
};

template<typename T>
class InputStream : public Stream<T>
{
public:
    Optional<T> get()
    {
        T item;
        if (get(item))
        {
            return {item};
        }
        return {};
    }
    virtual bool get(T& item) = 0;
};

template<typename T>
class OutputStream : public Stream<T>
{
public:
    virtual void write(T* data, size_t size) = 0;
};